package yourdomain
{
    import flash.display.DisplayObjectContainer;

    import org.robotlegs.base.ContextEvent;
    import org.robotlegs.mvcs.Context;

    import yourdomain.controllers.commands.mappings.MapViewsCommand;
    import yourdomain.controllers.events.MappingsEvent;

    /**
     *
     * [Ondina D. F.]
     *
     */
    public class ApplicationContext extends Context
    {
        private var _view:Object;

        public function ApplicationContext(contextView:DisplayObjectContainer = null, autoStartup:Boolean = true)
        {
            trace("Constructor ApplicationContext(contextView, autoStartup) " + contextView);
			
            _view = contextView;

            super(contextView, autoStartup);
        }

        override public function startup():void
        {
            registerListeners();

            mapMappingsCommands();

            super.startup();
        }

        private function mapMappingsCommands():void
        {
			trace("ApplicationContext.mapMappingsCommands()");
			
            commandMap.mapEvent(MappingsEvent.START_MAPPING, MapViewsCommand, MappingsEvent, true);
            dispatchEvent(new MappingsEvent(MappingsEvent.START_MAPPING));
        }

        private function addViews():void
        {
            trace("ApplicationContext.addViews()");
			
			/////////////////////////////////////// [[[option 3]]]
            _view.createChildren();
        }

        private function onMappingComplete(event:MappingsEvent):void
        {
			trace("ApplicationContext.onMappingComplete(event)");
        }

        private function onStartUpComplete(event:ContextEvent):void
        {
            trace("**********************************************************************************");
            trace("***** ApplicationContext.onStartUpComplete(ContextEvent.STARTUP_COMPLETE) *******");
            trace("**********************************************************************************");
            addViews();
			removeListeners();
        }

        private function registerListeners():void
        {
            this.addEventListener(ContextEvent.STARTUP_COMPLETE, onStartUpComplete); //dispatched by Context.startup()
            this.addEventListener(MappingsEvent.MAPPING_COMPLETE, onMappingComplete); //dispatched by MapViewsCommand after mapping the views			
        }

        private function removeListeners():void
        {
            this.removeEventListener(ContextEvent.STARTUP_COMPLETE, onStartUpComplete);
            this.removeEventListener(MappingsEvent.MAPPING_COMPLETE, onMappingComplete);
        }
    }
}
